document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {

    if ((window.device.platform == 'iOS') && (parseFloat(window.device.version) >= 7.0)) {
		//document.body.style.marginTop = "20px";
        $(".ui-header > *").css("margin-top", function (index, curValue) {return parseInt(curValue, 10) + 20 + "px";});
    }

    setTimeout(function() {
        navigator.splashscreen.hide();
    }, 2000);

    document.addEventListener("offline", function() { alert("No internet connection"); }, false);
    document.addEventListener("backbutton", onBackKeyDown, false);

   
    //pregunta per la versio actual
    FB.init({
        appId : auth.fbId,
        nativeInterface : CDV.FB,
        useCachedDialogs : false
    }); 
    // When keyboard is closed on a input type text, page scroll to UP
    $("input[type=text], textarea").bind("blur", function(e) {
        window.scrollTo(0,0);
    });
    // When keyboard is closed on a input type tel, page scroll to UP
    $("input[type=tel], textarea").bind("blur", function(e) {
        window.scrollTo(0,0);
    });
    try{
        window.localStorage.setItem("gaplugin", "true");
        gaPlugin = window.plugins.gaPlugin;
        gaPlugin.init(successHandler, errorHandler, "UA-40431099-1", 600);
    }catch(e){
        window.localStorage.setItem("gaplugin", "false");
    }  
}

startApplication();
deviceHeight=$(window).height();
$('#bgLeft img').css('height', deviceHeight + 'px', 'important');

var auth = new function() {

    this.fbId = "208185059337550";
    //this.fbId = "696466060370522";
    
    this.FBlogin = function(tipus) {
        //alert('entrem a login facebook');
        FB.login(function(response) {
            var uid = null; 
            try {
                uid = response.authResponse.userId;
                //alert(uid);
            } catch (e) {
               customAlert("Error de Login en Facebook!",1,0,"",3,false);
                //main.errorLog(e, "FB.login");
            }

            // iOs Hack other property name
            if (!uid && navigator.userAgent.match(/(iPhone)/i)) {
                try {
                    uid = response.authResponse.userID;
                } catch (e) {
                    //main.errorLog(e, "FB.login");
                }
            }
            //alert(response.status);
            if (response.status == 'connected') {
                /*main.loadAjax(main.ajaxPrefix + '/auth/loginsocial/', {
                    fbId : uid,
                    access_token: response.authResponse.accessToken,
                    secret: TOP_SECRET_GENERATED_HASH
                });*/
                //alert('connectat');
                auth.FBshare(tipus);
             
                
            } else if (response.status === 'not_authorized') {
                customAlert("Da permisos a la App de Buonjobs para que acceda a tu muro, y comparte de nuevo!",1,0,"",3,false);
            } else {
                //alert('Unknown error in authentication');
            }
        }, {scope : "email"});
    }

    this.FBLoginStatus = function(tipus) {
     
        FB.getLoginStatus(function(response) {
            if (response.status === 'connected') {
                // the user is logged in and has authenticated your
                // app, and response.authResponse supplies
                // the user's ID, a valid access token, a signed
                // request, and the time the access token 
                // and signed request each expire
                //alert('connectat');
                var uid = response.authResponse.userID;
                var accessToken = response.authResponse.accessToken;
                auth.FBshare(tipus);
            } else if (response.status === 'not_authorized') {
                // the user is logged in to Facebook, 
                // but has not authenticated your app
                customAlert("Da permisos a la App de Buonjobs para que acceda a tu muro, y comparte de nuevo!",1,0,"",3,false);
            } else {
                // the user isn't logged in to Facebook.
                //alert('user not logged');
                auth.FBlogin(tipus);
            }
        });
    }

    this.FBshare = function(tipus) {
        //alert('entrem a compartir app');
        if(tipus=="client"){
        	FB.ui({
                method: 'feed',
                link: 'http://buonjobs.com',
                picture: 'http://buonjobs.com/buon_logo.png',
                name: 'BuonJobs',
                caption: '&#191;Eres profesional y quieres acceder f&#225;cilmente a m&#225;s clientes&#63; &#191;Eres experto en algo y quieres trabajos&#63; &#191;Quieres facturar m&#225;s o tener ingresos extras&#63;',
                description: 'BuonJobs, es una aplicaci&#243;n para m&#243;vil, que te ofrece la posibilidad de llegar a todos los clientes que buscan un profesional como t&#250;. BuonJobs, no es INTERMEDIARIA, ni cobra COMISI&#211;N alguna, TODOS los profesionales que se registran tienen las mismas posibilidades de ser contratados para realizar el trabajo por el cual han realizado su cotizaci&#243;n (presupuesto).'
            }, function(response){
                 //alert(JSON.stringify(response));
            });
        	
        }else{
        	FB.ui({
                method: 'feed',
                link: 'http://buonjobs.com',
                picture: 'http://buonjobs.com/buon_logo.png',
                name: 'BuonJobs',
                caption: '&#191;Necesitas a un buen profesional sin necesidad de mover cielo y tierra&#63; &#191;Quieres comparar precios&#63; &#191;Te gustar&#237;a saber cu&#225;l es el mejor precio y qui&#233;n se adapta m&#225;s a tus necesidades&#63;',
                description: 'Buonjobs, te lo pone f&#225;cil, tu dices lo que necesitas y ellos te enviar&#225;n sus propuestas, con la m&#225;xima privacidad, tu ser&#225;s el que decidas cuando quieres que vean tus datos de contacto',     
            },function (response){
            	                
                if (response == "OK") {
                    app.navigate("propostaProfesional", true);
                }
                else if (response.post_id){
                    app.navigate("propostaProfesional", true);
                }
                else{
                	//alert(JSON.stringify(response));
                    customAlert("Lo sentimos, no se ha podido compartir la aplicación en facebook!",1,0,"",3,false);
                }

            });
        }
   	
    }
}

sendAuthentication = function (xhr) {
    var modelUser = JSON.parse(window.localStorage.getItem("auth"));
    var user = modelUser.username;
    var pass = modelUser.clau;
    var token = user.concat(":", pass);
    xhr.setRequestHeader('Authorization', ("Basic ".concat(btoa(token))));
}


var s3Uploader = (function () {

	   
    function upload(imageURI, fileName) {

    	var deferred = $.Deferred();
    	var ft = new FileTransfer();
        var options = new FileUploadOptions();
       	
    	options.fileKey = "file";
        options.fileName = fileName;
        options.mimeType = "image/jpeg";
        options.chunkedMode = false;

    	var signingURI = window.IPServidor+ "/signing";
    	$.ajax({url: signingURI, dataType: "json", type: "GET"})
            .done(function (data) {
                //alert(data.awsKey);
            	options.params = {
                    "key": fileName,
                    "AWSAccessKeyId": data.awsKey,
                    "acl": "public-read",
                    "policy": data.policy,
                    "signature": data.signature,
                    "Content-Type": "image/jpeg"
                };
                
                ft.upload(imageURI,window.IPServidor + '/uploadImage',
                        function (e) {
              //  			alert("ok");
                			deferred.resolve(e);
                        },
                        function (e) {
                //            alert("Upload failed");
                  //          alert(JSON.stringify(e));
                            deferred.reject(e);
                        }, options);
              

            })
            .fail(function (error) {
             //   alert(JSON.stringify(error));
            });
      
        return deferred.promise();

    }

    return {
        upload: upload
    }

}());


function preventDefault(e) { e.preventDefault(); };

function blockScroll(){ document.body.addEventListener('touchmove', preventDefault, false); }

function displayScroll(){ document.body.removeEventListener('touchmove', preventDefault, false); }

function onBackKeyDown(){
	var logged = window.localStorage.getItem("logged");
	
	if($("#home").length>0){
        navigator.app.exitApp();//menu principal

    }else if($("profesional_login").length>0){
        app.navigate('',true);

    }else if($("#client_login").length>0){
        app.navigate('',true);
    }else if($("#tutorial").length>0){
        app.navigate('',true);
    }
    else if($("#acercad").length>0){
        app.navigate('',true);
    }
    else if($('#primeraPantalla').length>0){
     	customAlert("Seguro que quiere salir de la aplicación?",2,0,"",6,false);
    }
    else{
       
    	navigator.app.exitApp();
    }
}

function loadingSpinner(method){
    if (method == "on") {
        //Adjust to screen size
        var pHeight = window.innerHeight;
        var pWidth =window.innerWidth;
        var sH = parseInt($('#loadingSpinner').css('height'));
        var sW = parseInt($('#loadingSpinner').css('width'));
        $('#loadingSpinner').css('top',(pHeight-sH)/2)
        $('#loadingSpinner').css('left',(pWidth-sW)/2)
        var maxZ = 200;
        $('#loadingSpinner').css('z-index',maxZ);
        //Show
        $('#loadingSpinner').show();
        $('html').css({'overflow-y':'hidden'});
    } else if (method == "off"){
        $('#loadingSpinner').hide();
        $('html').css({'overflow-y':'visible'});
    }
}

function showImage(path){
    $('.alertMessage').text("");
    $('.alertMessage').css('display', 'none');
    //alert(path);
    $('.customAlert').css('width', $(window).width() + 'px', 'important');
    //$('#alert1').css('display', 'block');
    $('.alertImage').css('display', 'block');
    $('.alertImage').attr("src", path);
    $('.alertImage').css('width', $(window).width() + 'px', 'important');

    totalHeight = 0;
    $(".customAlert").children().each(function(){
        if($(this).css('display') != 'none'){
            totalHeight = totalHeight + $(this).outerHeight();
        }
    });

    $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
    delete window.totalHeight;

    $('#alertMessage').animate({height: $(window).height(), top:0, opacity:1},100, function(){
        $('.alertImage').unbind('click');
        $('.alertImage').click(function() {
            $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                //$('#alert1').css('display', 'none');
                $('.alertImage').css('display', 'none');
                $('.alertImage').attr("src", "");
            });
        });
    });
}
  
//customAlert(msg: string, buttons: int, time: int, appNavigate: string, back: int, menu: boolean, title: string, cathegory: boolean);
function customAlert(msg,buttons,time,appNavigate,back,menu,title,cathegory,cathEv){
	
    //alert('customAlert');

    $('.customAlert').css('width', $(window).width() + 'px', 'important');

    $('.alertMessage').css('display', 'block');
    $('.alertMessage').text(msg);
    if(title!='' && typeof title != "undefined"){
        $('.titleMessage').text(title);
        $('.titleMessage').css('display', 'block');
        title='';
    }
    if(buttons==1){
        $('#alert1').css('display', 'block');
    }else if(buttons==2){
        $('#alert2').css('display', 'block');
    }
    totalHeight = 0;
    $(".customAlert").children().each(function(){
        if($(this).css('display') != 'none'){
            totalHeight = totalHeight + $(this).outerHeight();
        }
    });

    $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
    delete window.totalHeight;

    $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
        ////console.log(buttons);
        if(buttons==0){
            setTimeout(function(){
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    //$('.customAlert').empty();
                    //alert('entrem a butons 0');
                    closePage(back, appNavigate, menu);
                    $('.titleMessage').css('display', 'none');
                });
            }, time);
        }else if(buttons==1){
            $('#alert1').unbind('click');
            $('#alert1').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    //alert('entrem a butons 1');
                    //$('.customAlert').empty();
                    $('#alert1').css('display', 'none');
                    if(back==0 || back==1 || back==2){
                        loadingSpinner("on");
                        closePage(back, appNavigate, menu);
                    }
                    $('.titleMessage').css('display', 'none');
                });
            });
        }else if(buttons==2){
            //alert('entrem a butons 2');
            $('#alertAccept').unbind('click');
            $('#alertAccept').click(function() {
                $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    if(cathegory){
                        categoria=$(cathEv.currentTarget).text();
                        $("a[data-categoria='reparacions']").text($(cathEv.currentTarget).text());
                        dropdown=false;
                        $('#dropdown').animate({height:$('#DropContent a').outerHeight(true)});
                        $("#dropButton").attr("src","img/button_login_cliente.png");
                        $('#errorVerificarCategoria').css({'display':'none'});
                    }else{
                        loadingSpinner("on");
                        closePage(back, appNavigate, menu);
                    }
                    $('.titleMessage').css('display', 'none');
                });
            });
            $('#alertCancel').unbind('click');
            $('#alertCancel').click(function() {
                $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                    $('#alert2').css('display', 'none');
                    $('.titleMessage').css('display', 'none');
                    $('.alertMessage').text("");
                    $('.alertMessage').css('display', 'none');
                });
            });
        }
    });
    
    
    function closePage(back, appNavigate, menu){
       
        if(menu){
        
        	//alert('entrem a close page');
        	if(typeof device != "undefined"){

                var deviceid = window.localStorage.getItem("deviceid");
               
                var urldevice;
                
                if (device.platform == 'android' || device.platform == 'Android') {
                    urldevice = window.IPServidor + '/api/buonjobs/device/gcm/' + deviceid +'/';
                }else {
                    urldevice = window.IPServidor + '/api/buonjobs/device/apns/' + deviceid +'/';
                }
                
                pushNotification = window.plugins.pushNotification;
                pushNotification.unregister(successHandler, errorHandler);
                //alert('despres unregister');
                if(back == 5){//es dona de baixa
                    var urllogout = window.IPServidor + '/api/buonjobs/user/logout';
                    $.ajax({
                        url:urllogout,
                        type:'GET',
                        dataType:"json",
                        contentType:"application/json",
                        success:function (data) {
                              loadingSpinner("off");
                              window.localStorage.clear();
                            
                              app.navigate('', {trigger: true, replace: true});
                        },
                        error: function (errormessage) {
                             loadingSpinner("off");
                             window.localStorage.clear();
                             app.navigate('', {trigger: true, replace: true});
                        }
                    });    
                }
                $.ajax({
                    url:urldevice,
                    type:'DELETE',
                    dataType:"json",
                    beforeSend: sendAuthentication,
                    contentType:"application/json",
                    success:function (data) {
                                      
                        var modelUser = JSON.parse(window.localStorage.getItem("user"));
                      
                        var urllogout = window.IPServidor + '/api/buonjobs/user/logout';
                        
                        $.ajax({
                                url:urllogout,
                                type:'GET',
                                dataType:"json",
                                contentType:"application/json",
                                success:function (data) {
                                	  loadingSpinner("off");
                                      window.localStorage.clear();
                                  	
                                      app.navigate('', {trigger: true, replace: true});
                                },
                                error: function (errormessage) {
                                	 loadingSpinner("off");
                                     window.localStorage.clear();
                                     app.navigate('', {trigger: true, replace: true});
                                }
                        });
                      
                
                       
                    },
                    error: function (errormessage) {
                        var modelUser = JSON.parse(window.localStorage.getItem("user"));
                        var urllogout = window.IPServidor + '/api/buonjobs/user/logout';
                        $.ajax({
                            url:urllogout,
                            type:'GET',
                            dataType:"json",
                            contentType:"application/json",
                            success:function (data) {
                             	  loadingSpinner("off");
                                  window.localStorage.clear();
                              	
                                  app.navigate('', {trigger: true, replace: true});
                            },
                            error: function (errormessage) {
                            	 loadingSpinner("off");
                                 window.localStorage.clear();
                                 app.navigate('', {trigger: true, replace: true});
                            }
                        });

                    }
                });
                   
            }
    
         
        }
        //console.log(back);
        if(back==1){
            //alert('history back 1');
            window.history.back();
        }else if(back==2){
            //alert('history back 2');
            window.history.back();
            window.history.back();
        }else if(back==0){
            //alert('history back 0');
            app.navigate(appNavigate, true);
        }else if(back==5){
            window.history.back();
            window.history.back();
            window.history.back();
        }
        else if(back==6){
        	navigator.app.exitApp();
        }
    
        $('.alertMessage').text("");
        $('.alertMessage').css('display', 'none');
    }
}

function startApplication(){

    utils.loadTemplate(
        ['PropostaValoradaView',
        'ValorarPropostaView',
        'HistorialClientView',
        'PropostaAcepRechView',
        'OfertaClientView',
        'OfertaLlistatModificarView',
        'MenuPrincipalProfesionalView',
        'PropostaClientView',
        'BuscarDesdeProfesionalView',
        'PropostesProfesionalItemView',
        'PropostesProfesionalView',
        'PropostesClientItemView',
        'PropostesClientView',
        'PropostaProfesionalView',
        'MenuPrincipalView',
        'OfertaLlistatItemView',
        'OfertaLlistatView',
        'MailConfirmacioProfesionalView',
        'LoginClientView',
        'RegistreProfesionalView',
        'LoginProfesionalView',
        'RegistreClientView',
        'MailConfirmacioView',
        'MenuPrincipalClientView',
        'CrearOfertaView',
        'OfertaProfesionalView',
        'ContrassenyaOblidadaView',
        'GestioContaClientView',
        'GestioContaProfesionalView',
        'MailPasswordView',
        'AcercadeView',
        'TutorialView',
        'UpdateVersionView',
        'ComprarPropostaView'],

        function() {
            //window.IPServidor = 'http://172.16.14.22:8008';
            //window.IPServidor = 'http://2.139.203.136:7500';
            s3URI = "https://buonjobs.s3.amazonaws.com/";
            
            window.IPServidor = 'https://buonjobs.com';
            app = new AppRouter();
            Backbone.history.start();
        }
    );

    var AppRouter = Backbone.Router.extend({

        routes: {
            ""                  : "mostraMenuPrincipal",
            "loginClient"       : "mostraLoginClient",
            "registreClient"    : "mostraRegistreClient",
            "mailClient"        : "mostraMailClient",
            "menuClient"        : "mostraMenuClient",
            "crearOferta"       : "mostraCrearOferta",
            "loginProfesional"  : "mostraLoginProfesional",
            "registreProfesional"  : "mostraRegistreProfesional",
            "mailProfesional"      : "mostraMailProfesional",
            "menuProfesional"      : "mostraMenuProfesional",
            "verOfertasProfesional": "mostraVerOfertasProfesional",
            "ofertaProfesional": "mostraOfertaProfesional",
            "propostaProfesional": "mostraPropostaProfesional",
            "gestionPropuestasClient":"mostraPropostesClient",
            "gestionPropuestasProfesional":"mostraPropostesProfesional",
            "buscarDesdeAquiProfesional":"mostraOfertesDesdeProfesional",
            "propostaClient":"mostraPropostaClient",
            "modificarOferta":"modificaOfertesClient",
            "modificarOfertaClient":"modificaOfertaClient",
            "propostaAcepRech":"propostaAcepRech",
            "historial":"historialClient",
            "valorarProposta":"valoraPropostaClient",
            "propostaValoradaClient":"propostaValoradaClient",
            "forgotPass":"contrassenyaOblidada",
            "gestioContaClient":"gestioContaClient",
            "gestioContaProfesional":"gestioContaProfesional",
            "mailPassword":"mailPassword",
            "acercade":"acercade",
            "tutorial":"tutorial",
            "updateVersion":"updateVersion",
            "comprarProposta":"comprarProposta"
        },

        mostraMenuPrincipal: function () {
            var menuPrincipalView = new MenuPrincipalView();
            $('#content').html(menuPrincipalView.el);
        },

        mostraLoginClient: function () {
            var loginClientView = new LoginClientView();
            $('#content').html(loginClientView.el);
        },

        mostraRegistreClient: function () {
            var registreClientView = new RegistreClientView();
            $('#content').html(registreClientView.el);
        },

        mostraMailClient: function () {
            var mailConfirmacioView = new MailConfirmacioView();
            $('#content').html(mailConfirmacioView.el);
        },

        mostraMenuClient: function () {
            var menuPrincipalClientView = new MenuPrincipalClientView();
            $('#content').html(menuPrincipalClientView.el);
        },

        mostraCrearOferta: function () {
            var crearOfertaView = new CrearOfertaView();
            $('#content').html(crearOfertaView.el);
        },

        mostraLoginProfesional: function () {
            var loginProfesionalView = new LoginProfesionalView();
            $('#content').html(loginProfesionalView.el);
        },

        mostraRegistreProfesional: function () {
            var registreProfesionalView = new RegistreProfesionalView();
            $('#content').html(registreProfesionalView.el);
        },

        mostraMailProfesional: function () {
            var mailConfirmacioProfesionalView = new MailConfirmacioProfesionalView();
            $('#content').html(mailConfirmacioProfesionalView.el);
        },

        mostraMenuProfesional: function () {
            var menuPrincipalProfesionalView = new MenuPrincipalProfesionalView();
            $('#content').html(menuPrincipalProfesionalView.el);
        },
        
        mostraVerOfertasProfesional: function () {
            var ofertaLlistatView = new OfertaLlistatView();
            //alert(Backbone.history.fragment);
           
            $('#content').html(ofertaLlistatView.el);
        },

        mostraOfertaProfesional: function () {
            var ofertaProfesionalView = new OfertaProfesionalView();
            
            $('#content').html(ofertaProfesionalView.el);
        },

        mostraPropostaProfesional: function () {
            var propostaProfesionalView = new PropostaProfesionalView();
            $('#content').html(propostaProfesionalView.el);
        },

        mostraPropostesClient: function () {
            var propostesClientView = new PropostesClientView();
            $('#content').html(propostesClientView.el);
        },
        mostraPropostesProfesional: function () {
            var propostesProfesionalView = new PropostesProfesionalView();
            $('#content').html(propostesProfesionalView.el);
        },
        
        mostraOfertesDesdeProfesional: function (e ) {
            var buscarDesdeProfesionalView = new BuscarDesdeProfesionalView();
            $('#content').html(buscarDesdeProfesionalView.el);
        },

        mostraPropostaClient: function () {
            var propostaClientView = new PropostaClientView();
            $('#content').html(propostaClientView.el);
        },

        modificaOfertesClient: function () {
            var ofertaLlistatModificarView = new OfertaLlistatModificarView();
            $('#content').html(ofertaLlistatModificarView.el);
        },

        modificaOfertaClient: function () {
            var ofertaClientView = new OfertaClientView();
            $('#content').html(ofertaClientView.el);
        },

        propostaAcepRech: function (e ) {
            var propostaAcepRechView = new PropostaAcepRechView();
            $('#content').html(propostaAcepRechView.el);
        },

        historialClient: function () {
            var historialClientView = new HistorialClientView();
            $('#content').html(historialClientView.el);
        },

        valoraPropostaClient: function () {
            var valorarPropostaView = new ValorarPropostaView();
            $('#content').html(valorarPropostaView.el);
        },

        propostaValoradaClient: function (e ) {
            var propostaValoradaView = new PropostaValoradaView();
            $('#content').html(propostaValoradaView.el);
        },

        contrassenyaOblidada: function (e ) {
            var contrassenyaOblidadaView = new ContrassenyaOblidadaView();
            $('#content').html(contrassenyaOblidadaView.el);
        },

        gestioContaClient: function (e ) {
            var gestioContaClientView = new GestioContaClientView();
            $('#content').html(gestioContaClientView.el);
        },

        gestioContaProfesional: function (e ) {
            var gestioContaProfesionalView = new GestioContaProfesionalView();
            $('#content').html(gestioContaProfesionalView.el);
        },

        mailPassword: function (e ) {
            var mailPasswordView = new MailPasswordView();
            $('#content').html(mailPasswordView.el);
        },

        acercade: function ( e ) {
            var acercadeView = new AcercadeView();
            $('#content').html(acercadeView.el);
        },

        tutorial: function ( e ) {
            var tutorialView = new TutorialView();
            $('#content').html(tutorialView.el);
        },

        updateVersion: function ( e ) {
            var updateVersionView = new UpdateVersionView();
            $('#content').html(updateVersionView.el);
        },

        comprarProposta: function ( e ) {
            var comprarPropostaView = new ComprarPropostaView();
            $('#content').html(comprarPropostaView.el);
        }
    });
}