window.Oferta = Backbone.Model.extend({
    defaults: {
        client: '',
        resum: '',
        descripcio: '',
        categoria: '',
        direccio: '',
        imatges: '',
        urgent_flag: ''
    },
    url: 'https://buonjobs.com/api/buonjobs/oferta/'
});

window.Direccio = Backbone.Model.extend({
    defaults: {
        numero: '',
        carrer: '',
        ciutat: '',
        codipostal: '',
        latitud: '',
        longitud: ''
    },
    url: 'https://buonjobs.com/api/buonjobs/direccio/'
});

window.FotoOferta = Backbone.Model.extend({
    defaults: {
        imatgeOferta: ''
    },
    url: 'https://buonjobs.com/api/buonjobs/fotoOferta/'
});

window.OfertaModelLlistat = Backbone.Model.extend({
    defaults: {
        id: '',
        resum: '',
        caduca: '',
        ciutat: '',
        foto: ''
    }
});

window.CollectionOferta = Backbone.Collection.extend({
    url: 'https://buonjobs.com/api/buonjobs/oferta/',
    model: window.OfertaModelLlistat
});

window.Proposta = Backbone.Model.extend({
    defaults: {
        profesional: '',
        oferta: '',
        descripcio: '',
        justificacioPressupost: '',
        preumaxim: '',
        preuminim: '',
        preuHora: '',
        materialInclos: '',
        descripcioMaterial: '',
        estatAcceptacio: 0,
        dataCreacio: '',
        pagada: false
    },
    url: 'https://buonjobs.com/api/buonjobs/proposta/'
});

window.PropostaModelLlistat = Backbone.Model.extend({
    defaults: {
        id: '',
        nomprofesional: '',
        empresa: '',
        logo: '',
        resumoferta: '',
        estatAcceptacio: 0
    }
});

window.CollectionProposta = Backbone.Collection.extend({
    url: 'https://buonjobs.com/api/buonjobs/proposta/',
    model: window.PropostaModelLlistat
});