window.ComprarPropostaView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #btn_comprar_proposta':'vesAComprarProposta',
        'click #volver':'vesAPantallaAnterior',
        'click #btn_compartir_facebook':'vesACompartirFacebook'
    },

    renderSlider: function ( e ) {

        $('#verticalMidComprar').css('margin-top', (-$('#verticalMidComprar').outerHeight()/2) + 'px', 'important');
        $('#titol').css('margin-top', (-$('#titol').outerHeight()/2) - 150 + 'px', 'important');
        $('#volver').css('margin-top', (-$('#volver').outerHeight()/2) + 90 + 'px', 'important');

        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });

        loadingSpinner("off");
    },

    vesAPantallaAnterior: function ( e ) {
        //console.log("he clicat al boto de back");
        //alert('exit app');
        window.history.back();
    },

    vesAComprarProposta: function( e ) {
      
        e.preventDefault();
        loadingSpinner("on");
      
        $.ajax({
            //url: 'http://172.16.14.22/payment.php?cmd=openTrx', // A call to server side to initiate the payment process
            url: window.IPServidor + '/payment?cmd=openTrx',
            dataType:"html",
            cache: false,
            success: function(response) {
            	
        		eval(response);
            	            	
             	if(data.pagament == "false")
            	{
             		  loadingSpinner("off");
            		  customAlert(data.message,1,3000,"",3,false);
                      app.navigate("propostaProfesional", true);
            	}
             	else{
             	
	        		var isSandbox = true;
	        		if (data.isSandbox == "false"){
	        			isSandbox = false;
	        		}
	        		
	                var path = window.location.href.split('#');
	                
	                zoozStartCheckout({
	                    token : data.token,                         // Session token recieved from server
	                    uniqueId : "com.buonjobs.buonjobs",         // unique ID as registered in the developer portal
	                    isSandbox : isSandbox,                           // true = Sandbox environment
	                    returnUrl : path[0],                           // return page URL
	                    cancelUrl : path[0],                           // cancel page URL
	                    closeCallbackFunc : closed,
	                    completeCallBackFunc : complete
	                });
	        
             	}
            	
                //funció que s'executa quan s'acaba el procés de pagament
                function complete(response){
                    loadingSpinner("off");
                    app.navigate("propostaProfesional", true);

                }

                //funció que s'executa quan es cancela el procés de pagament
                function closed(response){
                    loadingSpinner("off");
                }
            },
            error: function (errormessage) {
                loadingSpinner("off");
                customAlert(JSON.parse(errormessage.responseText)["message"],0,1500,"",3,false);
            }
        });
    },

    vesACompartirFacebook: function ( e ) {
        e.preventDefault();
        //loadingSpinner("on");
        //auth.FBLoginStatus();
        this.customAlertFacebook("Si aceptas compartir en facebook la app, la propuesta es gratis!",2,3000,"",7,false);
        //app.navigate("propostaProfesional", true);
              

    },
    customAlertFacebook: function(msg,buttons,time,appNavigate,back,menu,title,cathegory,cathEv){
    	
        //alert('customAlert');

        $('.customAlert').css('width', $(window).width() + 'px', 'important');

        $('.alertMessage').css('display', 'block');
        $('.alertMessage').text(msg);
        if(title!='' && typeof title != "undefined"){
            $('.titleMessage').text(title);
            $('.titleMessage').css('display', 'block');
            title='';
        }
        $('#alert2').css('display', 'block');
       
        totalHeight = 0;
        $(".customAlert").children().each(function(){
            if($(this).css('display') != 'none'){
                totalHeight = totalHeight + $(this).outerHeight();
            }
        });

        $('.customAlert').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $('#alertMessage').animate({height:'100%', top:0, opacity:1},100, function(){
                $('#alertAccept').unbind('click');
                $('#alertAccept').click(function() {
                    $('#alertMessage').animate({height:0, top:'50%',opacity:0},300, function() {
                        $('#alert2').css('display', 'none');
                        $('.titleMessage').css('display', 'none');
                        auth.FBLoginStatus();
                    });
                });
                $('#alertCancel').unbind('click');
                $('#alertCancel').click(function() {
                    $('#alertMessage').animate({height:0, top:'50%', opacity:0},300, function() {
                        $('#alert2').css('display', 'none');
                        $('.titleMessage').css('display', 'none');
                        $('.alertMessage').text("");
                        $('.alertMessage').css('display', 'none');
                    });
                });
            
        });
	}
        
});
