window.ContrassenyaOblidadaView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #acceptar':'enviarContrassenya',
        'click #back_boto':'vesAPantallaAnterior',
        'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },

    renderSlider: function ( e ) {
        
        $('#formulariLoginClient').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            if($("#formulariLoginClient").valid()){
                loadingSpinner("on");
                
                var url = window.IPServidor + '/api/buonjobs/user/password_reset/';

                var correu = {correu: $('#correu').val()};

                $.ajax({
                    url:url,
                    type:'POST',
                    dataType:"json",
                    //beforeSend: sendAuthentication,
                    contentType:"application/json",
                    data: JSON.stringify(correu),
                    success:function (data) {
                        ////console.log(["Login request details: ", data]);
                        if(data.success) {
                            app.navigate('mailPassword', {trigger: true, replace: true});
                        }else{
                            //alert("error");
                        }
                    },
                    error: function (errormessage) {
                        //alert("error del servidor");
                        loadingSpinner("off");
                    }
                });
            }
        });
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $(this).removeClass('tapped');
            }, 1000);
        });
        
        totalHeight = 0;
        $("#formulariLoginClient").children().each(function(){
            totalHeight = totalHeight + $(this).outerHeight();
        });
        $('#formulariLoginClient').css('margin-top', -totalHeight/2 + 'px', 'important');
        delete window.totalHeight;

        $("#formulariLoginClient").validate({
            rules: {
                correu: {
                    required: true,
                    email: true
                }
            },
            focusInvalid: false,
            invalidHandler: function(form, validator) {
                if (!validator.numberOfInvalids())
                    return;
                $('html, body').animate({
                    scrollTop: $(validator.errorList[0].element).offset().top - 30
                }, 1000, 'swing', function(){$(validator.errorList[0].element).focus();});
            },
            errorPlacement: function(error, element) {
                error.insertAfter(element);
                error.addClass('campNoValid');
            }
        });

        var height = 50;
      
        $('.fixedBottom').css({'top':deviceHeight-height+'px'});

    	document.activeElement.blur();
        $("input").blur();
        window.scrollTo(0,0);
        loadingSpinner("off");
    },

    vesAPantallaAnterior: function ( e ) {
        //console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    },

    enviarContrassenya: function( event ) {
        event.preventDefault(); // Don't let this button submit the form
        
        if($("#formulariLoginClient").valid()){
            loadingSpinner("on");
            
            var url = window.IPServidor + '/api/buonjobs/user/password_reset/';

            var correu = {correu: $('#correu').val()};

            $.ajax({
                url:url,
                type:'POST',
                dataType:"json",
                //beforeSend: sendAuthentication,
                contentType:"application/json",
                data: JSON.stringify(correu),
                success:function (data) {
                    ////console.log(["Login request details: ", data]);
                    if(data.success) {
                        app.navigate('mailPassword', {trigger: true, replace: true});
                    }else{
                        //alert("error");
                    }
                },
                error: function (errormessage) {
                    //alert("error del servidor");
                    loadingSpinner("off");
                }
            });
        }
    }
});