window.MenuPrincipalView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
	    
        return this;
    },

    events:{
        'click #btn_client':'vesALoginClient',
        'click #btn_profesional':'vesALoginProfesional',
        'click #tutorial':'vesTutorial',
        'click #acercade':'vesAcercade'
    },

    renderSlider: function ( e ) {
        //$('.deviceHeight').css('height',$(window).height);
        //var myScroll = new iScroll('wrapper', { hScrollbar: false, vScrollbar: false });
        //var myScroll = new iScroll('wrapper');

        var urlupdates = window.IPServidor + '/checkUpdates';
        
        var deviceVersion = ({
            version:  '1.2.2'
        });
       
        $.ajax({
            url:urlupdates,
            type:'POST',
            dataType:"json",
            data : JSON.stringify(deviceVersion),
            contentType:"application/json",
            success:function (data) {
                
            	if(data.newVersion){
                    if(data.compulsory){
                        loadingSpinner("off");
                        app.navigate('updateVersion', {trigger: true, replace: true});
                    }
                }

                if(window.localStorage.getItem("user") != null)
                {
                    window.localStorage.setItem("directMenu","true");
                
                    var user = JSON.parse(window.localStorage.getItem("user"));
                   
                    if(typeof user.empresa != "undefined"){
                        app.navigate('menuProfesional', true);
                    }else{
                        app.navigate('menuClient', true);
                    }         
                }    
                else{
                    loadingSpinner("off");
                    window.localStorage.setItem("directMenu","false");
                    $('.btnHover').on('touchstart', function(e){
                         $(this).addClass('tapped');
                     });
                    $('.btnHover').on('touchend', function(e){
                         setTimeout(function(){
                             $('.btnHover').removeClass('tapped');
                         }, 200);
                    });
                }
            },
            error: function (errormessage) {
                 loadingSpinner("off");
                 if(window.localStorage.getItem("user") != null)
                 {
                     window.localStorage.setItem("directMenu","true");
                 
                     var user = JSON.parse(window.localStorage.getItem("user"));
                    
                     if(typeof user.empresa != "undefined"){
                         app.navigate('menuProfesional', true);
                     }else{
                         app.navigate('menuClient', true);
                     }         
                 }    
                 else{
                     loadingSpinner("off");
                     window.localStorage.setItem("directMenu","false");
                     $('.btnHover').on('touchstart', function(e){
                          $(this).addClass('tapped');
                      });
                     $('.btnHover').on('touchend', function(e){
                          setTimeout(function(){
                              $('.btnHover').removeClass('tapped');
                          }, 200);
                     });
                 }
            }
        });
      
        /*$.ajax({
            //url: 'http://172.16.14.22/payment.php?cmd=openTrx', // A call to server side to initiate the payment process
            url: 'http://172.16.14.22:8008/payment?cmd=openTrx',
            dataType: 'html',
            cache: false,
            success: function(response) {
                eval(response);
                alert(JSON.stringify(response));
                var path = window.location.href.split('#');
                alert(path[0]);
                
                zoozStartCheckout({
                    token : data.token,                         // Session token recieved from server
                    uniqueId : "com.buonjobs.buonjobs",         // unique ID as registered in the developer portal
                    isSandbox : true,                           // true = Sandbox environment
                    returnUrl : path[0],                           // return page URL
                    cancelUrl : path[0],                           // cancel page URL
                    closeCallbackFunc : closed,
                    completeCallBackFunc : complete
                });
        
                //funció que s'executa quan s'acaba el procés de pagament
                function complete(response){
                    alert("hello");
                }

                //funció que s'executa quan es cancela el procés de pagament
                function closed(){
                    alert("bye");
                }
            },
            error: function (errormessage) {
                alert("fail");
            }
        });*/
    },

    //https://sandbox.zooz.co/mobilewebsample/return.jsp?statusCode=0&trxId=UGC6AFANCGIBVRRHFTXNPPYCSI&trxToken=UGC6AFANCGIBVRRHFTXNPPYCSI&transactionID=UGC6AFANCGIBVRRHFTXNPPYCSI&transactionDisplayID=120077&token=DAV4SSDKPF73OCLKFV677JCUAQKBQZIZXGXPXJCS3GWB3QF2V2WMCRK5NNXEIYFX4FBMZFOGTWOAMYQFMHWJMMM3YJDUA7BBWYKXALU2FGFLZL7NE6YU2VHBF6UDZTE42F2L2TLBOCHC33LH5XBEXWOOT37XPIM46IDMGM3WPIHKTXVRBCSRT5V6LLF2CMRDDBBTNZUZHOSKBPFFRGC4YOJP2ATRRO6DT3NOTZA&sessionToken=DAV4SSDKPF73OCLKFV677JCUAQKBQZIZXGXPXJCS3GWB3QF2V2WMCRK5NNXEIYFX4FBMZFOGTWOAMYQFMHWJMMM3YJDUA7BBWYKXALU2FGFLZL7NE6YU2VHBF6UDZTE42F2L2TLBOCHC33LH5XBEXWOOT37XPIM46IDMGM3WPIHKTXVRBCSRT5V6LLF2CMRDDBBTNZUZHOSKBPFFRGC4YOJP2ATRRO6DT3NOTZA&status=Succeed

    vesALoginClient: function( e ) {
        e.preventDefault();
        loadingSpinner("on");
        app.navigate('loginClient', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Client - Menu Principal", "Click", "Menu Principal", 1);
        }
    },

    vesALoginProfesional: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        app.navigate('loginProfesional', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Professional - Menu Principal", "Click", "Menu Principal", 1);
        }
    },

    vesTutorial: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        app.navigate('tutorial', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Tutorial - Menu Principal", "Click", "Menu Principal", 1);
        }
    },

    vesAcercade: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        app.navigate('acercade', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button AcercaDe - Menu Principal", "Click", "Menu Principal", 1);
        }
    }
});

function nativePluginResultHandler (result) {
    //alert('success'+result);
    //success:'+ result +
}
function nativePluginErrorHandler (error) {
    //alert('error'+error);
    //error:'+ error +'
}