window.PropostaAcepRechView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    renderSlider: function ( e ) {
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        
        var modelProposta = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
        var load = false;
        if(modelProposta.get("profesional").logotip!=null){

            $('#imatgeOferta').attr("src",modelProposta.get("profesional").logotip).load(function(){
               load = true;
            });
        }else{
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        if(load == false){
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        $('#titulOferta').text(modelProposta.get("oferta").resum);
        $('#categoria').text(modelProposta.get("oferta").categoria);
        $('#informacioServei').text(modelProposta.get("oferta").descripcio);
        $('#descripcioProposta').text(modelProposta.get("descripcio"));
        $('#preuProposta').text('precio hora: '+modelProposta.get("preuHora"));
        $('#minMaxProposta').text('con un presupuesto mínimo de '+modelProposta.get("preuminim")+' y un máximo de '+modelProposta.get("preumaxim"));

        if(modelProposta.get("estatAcceptacio")==2){
            $('.header_titol p').text("propuesta aceptada");
            $('#carrer').text(modelProposta.get("oferta").direccio.carrer+','+modelProposta.get("oferta").direccio.numero);
            $('#ciutatCP').text(modelProposta.get("oferta").direccio.ciutat+','+modelProposta.get("oferta").direccio.codipostal);
            $('#nom').text(modelProposta.get("oferta").client.nom);
            $('#correu a').text(modelProposta.get("oferta").client.user.email);
            $('#telefon a').text(modelProposta.get("oferta").client.telefon);
            $('#correu a').attr('href','mailto:' + modelProposta.get("oferta").client.user.email);
            $('#telefon a').attr('href','tel:' + modelProposta.get("oferta").client.telefon);
        }else{
            $('.header_titol p').text("propuesta rechazada");
            $("#border2").css("display","none");
            $("#border3").css("display","none");
            $('#border1').addClass('border');
        }
        loadingSpinner("off");
    },
    vesAPantallaAnterior: function ( e ) {
        console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    }
});

