window.ValorarPropostaView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #enviarProposta':'enviaProposta',
        'touchstart .star':'rate',
        'click #comments1':'comments1',
        'click #comments2':'comments2',
        'blur input,textarea':'removeclassHeader',
		'focus input,textarea':'addclassHeader'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    renderSlider: function ( e ) {
        $('#formulari').on('submit', function(event) {
            event.preventDefault(); // cancel default form submit

            document.activeElement.blur();
            $("input").blur();
            window.scrollTo(0,0);
            
            loadingSpinner("on");
            var comentariValues = ({
                estrelles: puntuacio,
                comentari: $("#comentaris").val()
            });
            var valoracioModel = new window.Valoracio(comentariValues);
            valoracioModel.url = window.IPServidor + '/api/buonjobs/valoracio/';
            valoracioModel.save( {} , {
                beforeSend: sendAuthentication,
                error: function(model, response) {
                    //alert(response.responseText);
                    loadingSpinner("off");
                },
                success: function(model, response) {
                    var valoracioAPIURL = response.resource_uri;

                    var propostaModel = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
                    var propostaValues = ({
                        id: propostaModel.get("id"),
                        profesional: propostaModel.get("profesional").resource_uri,
                        oferta: propostaModel.get("oferta").resource_uri,
                        descripcio: propostaModel.get("descripcio"),
                        justificacioPressupost: propostaModel.get("justificacioPressupost"),
                        preumaxim: propostaModel.get("preumaxim"),
                        preuminim: propostaModel.get("preuminim"),
                        preuHora: propostaModel.get("preuHora"),
                        materialInclos: propostaModel.get("materialInclos"),
                        descripcioMaterial: propostaModel.get("descripcioMaterial"),
                        estatAcceptacio: 4,
                        valoracio: valoracioAPIURL
                    });
                    var propostaModel = new window.Proposta(propostaValues);
                    propostaModel.url = window.IPServidor + '/api/buonjobs/proposta/'+ propostaModel.get("id") + '/';

                    propostaModel.save( {} , {
                        beforeSend: sendAuthentication,
                        error: function(model, response) {
                            //alert(response.responseText);
                            loadingSpinner("off");
                        },
                        success: function(model, response) {
                            delete window.puntuacio;
                            customAlert("propuesta valorada!",0,2000,"",1,false);
                            if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                                gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ValorarProposta - Valorar Proposta", "Click", "Valorar Proposta", 1);
                            }
                        },
                    });
                },
            });
        });
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        var load = false;
        var modelProposta = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
        if(modelProposta.get("profesional").logotip!=null){
            $('#imatgeOferta').attr("src",modelProposta.get("profesional").logotip).load(function(){
               load = true;
            });
        }else{
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        if(load == false){
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        

        $('#titulOferta').text(modelProposta.get("oferta").resum);
        $('#categoria').text(modelProposta.get("oferta").categoria);
        $('#informacioServei').text(modelProposta.get("oferta").descripcio);
        $('#descripcioProposta').text(modelProposta.get("descripcio"));
        $('#preuProposta').text('precio hora: '+modelProposta.get("preuHora"));
        $('#minMaxProposta').text('con un presupuesto mínimo de '+modelProposta.get("preuminim")+' y un máximo de '+modelProposta.get("preumaxim"));
        puntuacio=0;
        loadingSpinner("off");
    },
    vesAPantallaAnterior: function ( e ) {
        //////console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    },
    rate: function ( e ) {
        if(parseInt($(e.currentTarget).attr('data-star'))==1 && $(e.currentTarget).attr('src')=="img/estrella_sencera.png" && $("[data-star='2']").attr('src')=="img/estrella_base.png"){
            $("[data-star='1']").attr("src","img/estrella_base.png");
            $("[data-star='2']").attr("src","img/estrella_base.png");
            $("[data-star='3']").attr("src","img/estrella_base.png");
            $("[data-star='4']").attr("src","img/estrella_base.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
            puntuacio=0;
        }else if(parseInt($(e.currentTarget).attr('data-star'))==1){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_base.png");
            $("[data-star='3']").attr("src","img/estrella_base.png");
            $("[data-star='4']").attr("src","img/estrella_base.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
            puntuacio=1;
        }else if(parseInt($(e.currentTarget).attr('data-star'))==2){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_base.png");
            $("[data-star='4']").attr("src","img/estrella_base.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
            puntuacio=2;
        }else if(parseInt($(e.currentTarget).attr('data-star'))==3){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_sencera.png");
            $("[data-star='4']").attr("src","img/estrella_base.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
            puntuacio=3;
        }else if(parseInt($(e.currentTarget).attr('data-star'))==4){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_sencera.png");
            $("[data-star='4']").attr("src","img/estrella_sencera.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
            puntuacio=4;
        }else if(parseInt($(e.currentTarget).attr('data-star'))==5){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_sencera.png");
            $("[data-star='4']").attr("src","img/estrella_sencera.png");
            $("[data-star='5']").attr("src","img/estrella_sencera.png");
            puntuacio=5;
        }
    },
    enviaProposta: function ( e ) {
        loadingSpinner("on");
        var comentariValues = ({
            estrelles: puntuacio,
            comentari: $("#comentaris").val()
        });
        var valoracioModel = new window.Valoracio(comentariValues);
        valoracioModel.url = window.IPServidor + '/api/buonjobs/valoracio/';
        valoracioModel.save( {} , {
            beforeSend: sendAuthentication,
            error: function(model, response) {
                //alert(response.responseText);
                loadingSpinner("off");
            },
            success: function(model, response) {
                var valoracioAPIURL = response.resource_uri;

                var propostaModel = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
                var propostaValues = ({
                    id: propostaModel.get("id"),
                    profesional: propostaModel.get("profesional").resource_uri,
                    oferta: propostaModel.get("oferta").resource_uri,
                    descripcio: propostaModel.get("descripcio"),
                    justificacioPressupost: propostaModel.get("justificacioPressupost"),
                    preumaxim: propostaModel.get("preumaxim"),
                    preuminim: propostaModel.get("preuminim"),
                    preuHora: propostaModel.get("preuHora"),
                    materialInclos: propostaModel.get("materialInclos"),
                    descripcioMaterial: propostaModel.get("descripcioMaterial"),
                    estatAcceptacio: 4,
                    valoracio: valoracioAPIURL
                });
                var propostaModel = new window.Proposta(propostaValues);
                propostaModel.url = window.IPServidor + '/api/buonjobs/proposta/'+ propostaModel.get("id") + '/';

                propostaModel.save( {} , {
                    beforeSend: sendAuthentication,
                    error: function(model, response) {
                        //alert(response.responseText);
                        loadingSpinner("off");
                    },
                    success: function(model, response) {
                        delete window.puntuacio;
                        customAlert("propuesta valorada!",0,2000,"",1,false);
                        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
                            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button ValorarProposta - Valorar Proposta", "Click", "Valorar Proposta", 1);
                        }
                    },
                });
            },
        });
    },

    comments1: function( e ) {
        customAlert("puntua del 1 al 5 el trabajo realizado por el profesional",1,0,"",3,false);
    },

    comments2: function( e ) {
        customAlert("puedes añadir algun comentario adicional referente al trabajo realizado por el profesional",1,0,"",3,false);
    }
});
