window.MenuPrincipalProfesionalView = Backbone.View.extend({

    initialize: function () {
        //this.bind("reset", this.updateView);
        this.render();
    
    },

    render: function () {
        $(this.el).html(this.template());
        $(this.el).show();
        $("#content").show();
        setTimeout(this.renderSlider, 0);
        return this;
    },

    /*updateView: function() {
       view.remove();
       view.render();
    };*/


    events:{
        'click #btn_ver_ofertas':'vesAVerOfertas',
        'click #back_boto':'vesAPantallaAnterior',
        'click #btn_buscar_ofertas':'vesABuscarOfertas',
        'click #btn_buscar_propuestas_aceptadas':'vesABuscarPropuestasAceptadas',
        'click #btn_buscar_propuestas_rechazadas':'vesABuscarPropuestasRechazadas',
        'click #btn_buscar_propuestas_valoradas':'vesABuscarPropuestasValoradas',
        'click #btn_settings':'mostraSettings',
        'click #gestioConta':'vesGestioConta',
        'click #compartir':'compartir',
        'click #logout':'surt'
    },

    renderSlider: function ( e ) {
        if(typeof device != "undefined"){
            if (device.platform == 'android' || device.platform == 'Android') {} else {
                $('#back_boto').css('display', 'none');
            }
        }

        $('#verticalMid').css('margin-top', (-$('#verticalMid').outerHeight()/2)+30 + 'px', 'important');

        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        dropdown=false;
                
        $.ajax({
            url: window.IPServidor + '/api/buonjobs/notificacio/',
            type:'GET',
            dataType:'json',
            beforeSend: sendAuthentication,
            contentType:'application/json',
            success:function (missatgeResposta) {

                var quantesNotificacions = missatgeResposta.objects.length;

                if(quantesNotificacions>0){
                    //alert("primera notificacio!");
                    var notificacions = {
                        "data": []
                    };
                    var number;
                    
                    for(var i=0;i<quantesNotificacions;i++) {                  
                        var valuesNotifications = ({
                            id: missatgeResposta.objects[i].id,
                            idNotificacio: missatgeResposta.objects[i].idTipus,
                            messageType: missatgeResposta.objects[i].tipus
                        });
                        notificacions.data.push(valuesNotifications);

                        if(missatgeResposta.objects[i].tipus==2){
                            $('#nA').css('display','block');
                            number = parseInt($('#nA p').text())+1;
                            $('#nA p').text(number);
                        }else if(missatgeResposta.objects[i].tipus==3){
                            $('#nR').css('display','block');
                            number = parseInt($('#nR p').text())+1;
                            $('#nR p').text(number);
                        }else if(missatgeResposta.objects[i].tipus==4){
                            $('#nV').css('display','block');
                            number = parseInt($('#nV p').text())+1;
                            $('#nV p').text(number);
                        }
                        else if(missatgeResposta.objects[i].tipus==5){
                            $('#nO').css('display','block');
                            number = parseInt($('#nO p').text())+1;
                            $('#nO p').text(number);
                        }

                    }
                    window.localStorage.setItem("notifications", JSON.stringify(notificacions));
                }
                loadingSpinner("off");
            },
            error: function (errormessage) {
                //alert("peticio recurs llistat ofertes fail");
                loadingSpinner("off");
            }
        });

        

        window.localStorage.removeItem("desDaqui");
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        
        dropdown=false;

        if(window.localStorage.getItem("notifications") != null){
            //var result = $.grep(notificacions.data, function(e){ return (e.PropostaId == id && e.MessageType == 0); });

            var notificacions = JSON.parse(window.localStorage.getItem("notifications"));
            var number;
            for(var i=0;i<notificacions.data.length;i++){
                if(notificacions.data.MessageType==2){
                    //alert("notificacio Acceptada");
                    $('#nA').css('display','block');
                    number = parseInt($('#nA p').text())+1;
                    $('#nA p').text(number);
                }else if(notificacions.data.MessageType==3){
                    //alert("notificacio Rechazada");
                    $('#nR').css('display','block');
                    number = parseInt($('#nR p').text())+1;
                    $('#nR p').text(number);
                }else if(notificacions.data.MessageType==4){
                    //alert("notificacio Valorada");
                    $('#nV').css('display','block');
                    number = parseInt($('#nV p').text())+1;
                    $('#nV p').text(number);
                }
                else if(notificacions.data.MessageType==5){
                    //alert("nova oferta");
                    $('#nO').css('display','block');
                    number = parseInt($('#nV p').text())+1;
                    $('#nO p').text(number);
                }
            }
        }

        loadingSpinner("off");
    },

    vesAPantallaAnterior: function ( e ) {
        //alert("he clicat al boto de back");
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
             gaPlugin.exit(nativePluginResultHandler, nativePluginErrorHandler);
        }
        //alert('exit app');
        navigator.app.exitApp();
    },

    compartir: function ( e ) {
        e.preventDefault();
        //auth.FBLoginStatus();
    	window.plugins.socialsharing.available(function(isAvailable) {
            if (isAvailable) {
                // use a local image from inside the www folder:
                window.plugins.socialsharing.share('', 'BuonJobs', 'http://buonjobs.com/buon_logo_profesional.png', 'http://buonjobs.com/'); // succes/error callback params may be added as 4th and 5th param
            }
        });
    },

    surt: function ( e ) {
        //alert('click sortir');
        customAlert("Seguro que quieres cerrar sesión?",2,0,"",3,true);
    },

    mostraSettings: function( e ){
        if(dropdown){
            dropdown=false;
            $('#settings').animate({height: 0}, function(){
                $('#settings').css({'display':'none'})
            });
        }else{
            dropdown=true;
            $('#settings').css({'display':'block'})
            $('#settings').animate({height: $('#DropContent').outerHeight()});
        }
    },

    vesAVerOfertas: function( e ) {
        e.preventDefault();
        loadingSpinner("on");
        window.localStorage.setItem("desDaqui", false);
        $(this.el).hide();
        $("#content").hide();
        app.navigate('verOfertasProfesional', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button VerOfertes - Menu Professional", "Click", "Menu Professional", 1);
        }
    },

    vesABuscarOfertas: function( e ) {
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('buscarDesdeAquiProfesional', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button BuscarOfertes - Menu Professional", "Click", "Menu Professional", 1);
        }
    },
    vesABuscarPropuestasAceptadas: function( e ) {
        window.estatAcceptacio = 2;
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('gestionPropuestasProfesional', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button PropostesAcceptades - Menu Professional", "Click", "Menu Professional", 1);
        }
    },
    vesABuscarPropuestasRechazadas: function( e ) {
        window.estatAcceptacio = 3;
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('gestionPropuestasProfesional', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button PropostesRebutjades - Menu Professional", "Click", "Menu Professional", 1);
        }
    },
    vesABuscarPropuestasValoradas: function( e ) {
        window.estatAcceptacio = 4;
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('gestionPropuestasProfesional', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button PropostesValorades - Menu Professional", "Click", "Menu Professional", 1);
        }
    },

    vesGestioConta: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        $(this.el).hide();
        $("#content").hide();
        
        app.navigate('gestioContaProfesional', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button GestioConta - Menu Professional", "Click", "Menu Professional", 1);
        }
    }
});