window.OfertaProfesionalView = Backbone.View.extend({

    initialize: function () {
        this.model = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
        _.bindAll(this,"render","renderSlider");
        this.render();
    },

    render: function () {
        $(this.el).html(this.template(this.model.toJSON()));
        setTimeout(this.renderSlider, 0);
        return this;
    },

    renderSlider: function ( e ) {
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        
        if(this.model.attributes.imatges.length>0){
            $('#galeria').css({'display':'block'});
            //Main Swiper
            swiperDyn = $('.swiper-dynamic').swiper({
                pagination:'.pagination-sd'
            });
            for(var i=0;i<this.model.attributes.imatges.length;i++){
                var newSlide = swiperDyn.createSlide('<img id="ampliar" src="'+this.model.attributes.imatges[i].imatgeOferta+'"/>');
                newSlide.append();
            }
            //alert(this.model.attributes.imatges[0].imatgeOferta);
         
            var load = false;
            $('#mainImage').attr("src",this.model.attributes.imatges[0].imatgeOferta).load(function(){
                load = true;
            });
            if (load == false){
                $('#mainImage').attr("src","img/default_image.png");    
            }

        }else{
            $('#mainImage').attr("src","img/default_image.png");
        }
        loadingSpinner("off");
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior',
        'click #realizarPropuesta':'vesRealitzarProposta',

        'click #ampliar':'ampliar'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    ampliar: function(e){
        showImage(e.currentTarget.attributes[1].value);
    },

    vesAPantallaAnterior: function ( e ) {
        loadingSpinner("on");
        window.history.back();
    },

    vesRealitzarProposta: function ( e ) {
        $(this.el).hide();
        $("#content").hide();
       
        var modelOferta = new window.Oferta(JSON.parse(window.localStorage.getItem("offer")));
        var modelProfesional = new window.Profesional(JSON.parse(window.localStorage.getItem("user")));
     
        $.ajax({
            url: window.IPServidor + '/api/buonjobs/proposta/checkPropostaExistent?id_oferta=' + modelOferta.get("id") + '&id_professional=' + modelProfesional.get("id"),
            type:'GET',
            dataType:'json',
            beforeSend: sendAuthentication,
            contentType:'application/json',
            success:function (response) {
            	loadingSpinner("off");
                app.navigate("comprarProposta", true);
            },
            error: function (response) {
            	loadingSpinner("off");
            	customAlert(response.responseText,0,3000,"",2,false);
            }
        });
       
        //customAlert("Los primeros meses esta funcionalidad será gratuita, más adelante se tendrá que pagar una pequeña cantidad para utilitzarla",1,0,"propostaProfesional",0,false);
    }
});
