window.PropostaValoradaView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
        return this;
    },

    events:{
        'click #back_boto':'vesAPantallaAnterior'
    },
    addclassHeader: function( e ){
    	$('#headerTop').addClass("headerAbsolute");
    },
    
    removeclassHeader: function( e ){
    	$('#headerTop').removeClass("headerAbsolute");
    },
    renderSlider: function ( e ) {
        $('.btnHover').on('touchstart', function(e){
            $(this).addClass('tapped');
        });
        $('.btnHover').on('touchend', function(e){
            setTimeout(function(){
                $('.btnHover').removeClass('tapped');
            }, 200);
        });
        var load = false;
        var modelProposta = new window.Proposta(JSON.parse(window.localStorage.getItem("propose")));
        if(modelProposta.get("profesional").logotip!=null){
            $('#imatgeOferta').attr("src",modelProposta.get("profesional").logotip).load(function(){
               load = true;
            });
        }else{
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        if(load == false){
            $('#imatgeOferta').attr("src","img/default_image.png");
        }
        console.log(modelProposta);
        $('#titulOferta').text(modelProposta.get("oferta").resum);
        $('#categoria').text(modelProposta.get("oferta").categoria);
        $('#informacioServei').text(modelProposta.get("oferta").descripcio);
        $('#descripcioProposta').text(modelProposta.get("descripcio"));
        $('#preuProposta').text('precio hora: '+modelProposta.get("preuHora"));
        $('#minMaxProposta').text('con un presupuesto mínimo de '+modelProposta.get("preuminim")+' y un máximo de '+modelProposta.get("preumaxim"));

        if(modelProposta.get("estatAcceptacio")==1){
            $('#carrer').text(modelProposta.get("oferta").direccio.carrer);
            $('#ciutatCP').text(modelProposta.get("oferta").direccio.ciutat+', '+modelProposta.get("oferta").direccio.codipostal);
            $('#pais').text(modelProposta.get("oferta").direccio.pais);
            $('#nom').text(modelProposta.get("oferta").client.nom);
            $('#correu').text(modelProposta.get("oferta").client.user.email);
            $('#telefon').text(modelProposta.get("oferta").client.telefon);

            $('#border2').css({'display':'block'});
        }else{
            $('#border1').addClass('border');
        }
        if(parseInt(modelProposta.get("valoracio").estrelles)==1){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_base.png");
            $("[data-star='3']").attr("src","img/estrella_base.png");
            $("[data-star='4']").attr("src","img/estrella_base.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
        }else if(parseInt(modelProposta.get("valoracio").estrelles)==2){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_base.png");
            $("[data-star='4']").attr("src","img/estrella_base.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
        }else if(parseInt(modelProposta.get("valoracio").estrelles)==3){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_sencera.png");
            $("[data-star='4']").attr("src","img/estrella_base.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
        }else if(parseInt(modelProposta.get("valoracio").estrelles)==4){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_sencera.png");
            $("[data-star='4']").attr("src","img/estrella_sencera.png");
            $("[data-star='5']").attr("src","img/estrella_base.png");
        }else if(parseInt(modelProposta.get("valoracio").estrelles)==5){
            $("[data-star='1']").attr("src","img/estrella_sencera.png");
            $("[data-star='2']").attr("src","img/estrella_sencera.png");
            $("[data-star='3']").attr("src","img/estrella_sencera.png");
            $("[data-star='4']").attr("src","img/estrella_sencera.png");
            $("[data-star='5']").attr("src","img/estrella_sencera.png");
        }
        loadingSpinner("off");
    },
    vesAPantallaAnterior: function ( e ) {
        console.log("he clicat al boto de back");
        loadingSpinner("on");
        window.history.back();
    }
});