window.UpdateVersionView = Backbone.View.extend({

    initialize: function () {
        this.render();
    },

    render: function () {
        $(this.el).html(this.template());
        setTimeout(this.renderSlider, 0);
	    
        return this;
    },

    events:{
        'click #botoUpdate':'vesABotiga',
        'click #tutorial':'vesTutorial',
        'click #acercade':'vesAcercade'
    },

    renderSlider: function ( e ) {
        if(typeof device != "undefined"){
            if (device.platform == 'android' || device.platform == 'Android') {
                $('#googleplay').css({'display':'block'});
                $('#appmarket').css({'display':'none'});
            }
        }
        loadingSpinner("off");
        $('.btnHover').on('touchstart', function(e){
             $(this).addClass('tapped');
         });
        $('.btnHover').on('touchend', function(e){
             setTimeout(function(){
                 $('.btnHover').removeClass('tapped');
             }, 200);
        });
    },

    vesABotiga: function( e ) {
        e.preventDefault();
        if(typeof device != "undefined"){
            if (device.platform == 'android' || device.platform == 'Android') {
                window.open("market://details?id=com.medialabbcn.buon","_system");
            }else {
                window.open("itms-apps://itunes.apple.com/app/buonjobs/id719689962","_system");
            }
        }
    },

    vesTutorial: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        app.navigate('tutorial', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button Tutorial - Menu Principal", "Click", "Menu Principal", 1);
        }
    },

    vesAcercade: function ( e ) {
        e.preventDefault();
        loadingSpinner("on");
        app.navigate('acercade', true);
        if(typeof device != "undefined" && window.localStorage.getItem("gaplugin")=="true"){
            gaPlugin.trackEvent( nativePluginResultHandler, nativePluginErrorHandler, "Button AcercaDe - Menu Principal", "Click", "Menu Principal", 1);
        }
    }
});

function nativePluginResultHandler (result) {
    //alert('success'+result);
    //success:'+ result +
}
function nativePluginErrorHandler (error) {
    //alert('error'+error);
    //error:'+ error +'
}